///////////////////////////////////////////////////////////////////////////////
// NABLA - a Numerical Analysis Based LAnguage                               //
//                                                                           //
// Copyright (C) 2014~2016 CEA/DAM/DIF                                       //
// IDDN.FR.001.520002.000.S.P.2014.000.10500                                 //
//                                                                           //
// Contributor(s): CAMIER Jean-Sylvain - Jean-Sylvain.Camier@cea.fr          //
//                 LABOURASSE Emmanuel - Emmanuel.Labourasse@cea.fr          //
//                                                                           //
// This software is a computer program whose purpose is to translate         //
// numerical-analysis specific sources and to generate optimized code        //
// for different targets and architectures.                                  //
//                                                                           //
// This software is governed by the CeCILL license under French law and      //
// abiding by the rules of distribution of free software. You can  use,      //
// modify and/or redistribute the software under the terms of the CeCILL     //
// license as circulated by CEA, CNRS and INRIA at the following URL:        //
// "http://www.cecill.info".                                                 //
//                                                                           //
// The CeCILL is a free software license, explicitly compatible with         //
// the GNU GPL.                                                              //
//                                                                           //
// As a counterpart to the access to the source code and rights to copy,     //
// modify and redistribute granted by the license, users are provided only   //
// with a limited warranty and the software's author, the holder of the      //
// economic rights, and the successive licensors have only limited liability.//
//                                                                           //
// In this respect, the user's attention is drawn to the risks associated    //
// with loading, using, modifying and/or developing or reproducing the       //
// software by the user in light of its specific status of free software,    //
// that may mean that it is complicated to manipulate, and that also         //
// therefore means that it is reserved for developers and experienced        //
// professionals having in-depth computer knowledge. Users are therefore     //
// encouraged to load and test the software's suitability as regards their   //
// requirements in conditions enabling the security of their systems and/or  //
// data to be ensured and, more generally, to use and operate it in the      //
// same conditions as regards security.                                      //
//                                                                           //
// The fact that you are presently reading this means that you have had      //
// knowledge of the CeCILL license and that you accept its terms.            //
//                                                                           //
// See the LICENSE file for details.                                         //
///////////////////////////////////////////////////////////////////////////////
ofstream output("output.plot");
ofstream results("result.plot");


//∀ cells dumpGnuplotp @ 34.0 if (option_dump_at_end and (((iteration-1)%dump_iterations)==0))
// ****************************************************************************
// * Dump Gnuplot
// ****************************************************************************
∀ cells dmpMsh @ 35.0 if (option_dump_at_end and ((time+δt)>=option_stoptime)){
  if (uid==0) info()<<"\33[1;31m[dumpGnuplot] Now dumping to outputp.plot file!\33[0m";
  output << p << " ";
  ∀ node
    output << coord.x << " " << coord.y << " ";
  output << coord[0].x << " " << coord[0].y << " ";
  output << "\n";
  if (uid==NABLA_NB_CELLS-1) output << "\n\n";
}


// ****************************************************************************
// * Dump Solution
// ****************************************************************************
∀ cells dmpSol @ 35.0 if (option_dump_output and (time>=(option_stoptime-δt))){ 
  if (uid==0) info()<<"\33[1;31m[dumpSolution] Now dumping to result.plot file!\33[0m";
  results << "\t" << center.x 
          << "\t" << center.y
          << "\t" << p
          << "\t" << u.x
          << "\t" << u.y
          << "\t" << θ
          << "\t" << pana
          << "\t" << uana.x
          << "\t" << uana.y
          << "\t" << tana
          << "\n";
 }  
