///////////////////////////////////////////////////////////////////////////////
// NABLA - a Numerical Analysis Based LAnguage                               //
//                                                                           //
// Copyright (C) 2014~2017 CEA/DAM/DIF                                       //
// IDDN.FR.001.520002.000.S.P.2014.000.10500                                 //
//                                                                           //
// Contributor(s): RAMBAUD Albéric                                           //
//                 BUET Christophe - Christophe.Buet@cea.fr                  //
//                 CAMIER Jean-Sylvain - Jean-Sylvain.Camier@cea.fr          //
//                 LABOURASSE Emmanuel - Emmanuel.Labourasse@cea.fr          //
//                                                                           //
// This software is a computer program whose purpose is to translate         //
// numerical-analysis specific sources and to generate optimized code        //
// for different targets and architectures.                                  //
//                                                                           //
// This software is governed by the CeCILL license under French law and      //
// abiding by the rules of distribution of free software. You can  use,      //
// modify and/or redistribute the software under the terms of the CeCILL     //
// license as circulated by CEA, CNRS and INRIA at the following URL:        //
// "http://www.cecill.info".                                                 //
//                                                                           //
// The CeCILL is a free software license, explicitly compatible with         //
// the GNU GPL.                                                              //
//                                                                           //
// As a counterpart to the access to the source code and rights to copy,     //
// modify and redistribute granted by the license, users are provided only   //
// with a limited warranty and the software's author, the holder of the      //
// economic rights, and the successive licensors have only limited liability.//
//                                                                           //
// In this respect, the user's attention is drawn to the risks associated    //
// with loading, using, modifying and/or developing or reproducing the       //
// software by the user in light of its specific status of free software,    //
// that may mean that it is complicated to manipulate, and that also         //
// therefore means that it is reserved for developers and experienced        //
// professionals having in-depth computer knowledge. Users are therefore     //
// encouraged to load and test the software's suitability as regards their   //
// requirements in conditions enabling the security of their systems and/or  //
// data to be ensured and, more generally, to use and operate it in the      //
// same conditions as regards security.                                      //
//                                                                           //
// The fact that you are presently reading this means that you have had      //
// knowledge of the CeCILL license and that you accept its terms.            //
//                                                                           //
// See the LICENSE file for details.                                         //
///////////////////////////////////////////////////////////////////////////////
//Test 1 for linear advection (smooth data)
ℝ U_condlimi(ℝ x,ℝ t){
  return  1.0; //-epsilon + exp(-t/epsilon²) + epsilon/(2*tau-1)*exp(-2*tau*t/epsilon²) ;
}

// Test 2 for linear  advection (discontinuous data)
ℝ P_condlimi(ℝ x,ℝ t){
  return -sigma*x/(epsilon); //x*(1+ exp(-2*tau*t/epsilon²)) ;
}

ℝ T_condini(ℝ x){
  return -sigma*x/(epsilon);
}

ℝ T_condlimi(ℝ x){
  return -sigma*x/(epsilon); //-sigma*x;
}
  
ℝ P_condini(ℝ x,ℝ t){   
  return -x; //-sigma*x/(epsilon); //2*x ; 
  
}ℝ U_condini(ℝ x,ℝ t){
  return
    1.0; //epsilon + 1 + epsilon/(2*tau-1) ; //(x+1)*exp(-sigma*t);
} 
  
ℝ F_sigma(ℝ x){  
  return x; 
}

